/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FlowOperationSortRules type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FlowOperationSortRules{}

// FlowOperationSortRules struct for FlowOperationSortRules
type FlowOperationSortRules struct {
	// Column ID
	Column *string `json:"column,omitempty"`
	// Direction (eg. Asc, Desc)
	Direction *string `json:"direction,omitempty"`
}

// NewFlowOperationSortRules instantiates a new FlowOperationSortRules object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFlowOperationSortRules() *FlowOperationSortRules {
	this := FlowOperationSortRules{}
	return &this
}

// NewFlowOperationSortRulesWithDefaults instantiates a new FlowOperationSortRules object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFlowOperationSortRulesWithDefaults() *FlowOperationSortRules {
	this := FlowOperationSortRules{}
	return &this
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *FlowOperationSortRules) GetColumn() string {
	if o == nil || IsNil(o.Column) {
		var ret string
		return ret
	}
	return *o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationSortRules) GetColumnOk() (*string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *FlowOperationSortRules) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given string and assigns it to the Column field.
func (o *FlowOperationSortRules) SetColumn(v string) {
	o.Column = &v
}

// GetDirection returns the Direction field value if set, zero value otherwise.
func (o *FlowOperationSortRules) GetDirection() string {
	if o == nil || IsNil(o.Direction) {
		var ret string
		return ret
	}
	return *o.Direction
}

// GetDirectionOk returns a tuple with the Direction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationSortRules) GetDirectionOk() (*string, bool) {
	if o == nil || IsNil(o.Direction) {
		return nil, false
	}
	return o.Direction, true
}

// HasDirection returns a boolean if a field has been set.
func (o *FlowOperationSortRules) HasDirection() bool {
	if o != nil && !IsNil(o.Direction) {
		return true
	}

	return false
}

// SetDirection gets a reference to the given string and assigns it to the Direction field.
func (o *FlowOperationSortRules) SetDirection(v string) {
	o.Direction = &v
}

func (o FlowOperationSortRules) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FlowOperationSortRules) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.Direction) {
		toSerialize["direction"] = o.Direction
	}
	return toSerialize, nil
}

type NullableFlowOperationSortRules struct {
	value *FlowOperationSortRules
	isSet bool
}

func (v NullableFlowOperationSortRules) Get() *FlowOperationSortRules {
	return v.value
}

func (v *NullableFlowOperationSortRules) Set(val *FlowOperationSortRules) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowOperationSortRules) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowOperationSortRules) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowOperationSortRules(val *FlowOperationSortRules) *NullableFlowOperationSortRules {
	return &NullableFlowOperationSortRules{value: val, isSet: true}
}

func (v NullableFlowOperationSortRules) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowOperationSortRules) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
